import java.util.Scanner;

public class Source implements OutSignal, UpdateListener {
  private boolean output;
  private Simulator sim;
  private Scanner data;
  private Wire outWire;
  private static int nextId=0;
  private final int id;
  
  {  id = nextId++;
  }
  public Source(Scanner in, Simulator s) {
    sim = s;
    data = in;
    float t = data.nextFloat();
//    System.out.print("Source #"+id+"  "+t);
    sim.add(new ChangeEvent(this, t)); 
  }
  
  public void update() {
    int val = data.nextInt();
    float time=0;
    boolean nextValue = val==1;
    if(nextValue != output) {
        output = nextValue;
        outWire.notifyChange();
    }
    if (data.hasNextFloat()) {
       time = data.nextFloat();
      sim.add(new ChangeEvent(this, time));
    }
//    System.out.println("Source #"+id+"  "+time+"  "+val);
  }
  
  public boolean getOutput() {
    return output;
  }
  public void connectOutput(Wire w) {
    outWire = w;
    w.connectFrom(this);
  }
  public String getDescription() {
    return getClass().getName()+"#"+id;
  }
}