import java.util.Scanner;
import java.io.PrintStream;
import java.io.*;

public class DigitalCircuit {
  public static void main(String argv[]) {
	Simulator sim = new Simulator ();
    
	Not not0 = new Not (2f, sim);
	Not not1 = new Not (2f, sim);
    
	Wire w0 = new Wire();
	Wire w1 = new Wire();

	Meter meter = new Meter(getPrintStream(argv[0]));
    
	not0.connectInput(w0);
	not0.connectOutput(w1);
	not1.connectInput(w1);
	not1.connectOutput(w0);
    
	meter.addTestPoint(w0);
	meter.addTestPoint(w1);
    
	/* Here we check that each gate
       output agrees the gate logic. */
	not0.inputChanged(); /* b)  */
	not1.inputChanged(); /* b)  */
    
	sim.simulate(meter);
  }
  private static Scanner getScanner(String filename){
    Scanner s=null;
    try {
       s=new Scanner(new File(filename));
    } catch(FileNotFoundException e) {
      System.out.println("Error with file "+filename+":"+e.getMessage());
      System.exit(-1);
    } 
    return s;
  }
  private static PrintStream getPrintStream(String filename) {
    PrintStream out=null;
    try {
      out = new PrintStream( new File(filename));
    } catch(FileNotFoundException e) {
      System.out.println("Error with file "+filename+":"+e.getMessage());
      System.exit(-1);
    } 
    return out;
  }
} 
