import java.util.Scanner;
import java.io.PrintStream;
import java.io.*;

public class DigitalCircuit {
  public static void main(String argv[]) {
    Simulator sim = new Simulator ();
    
    And and0 = new And (0.5f, sim);
  
    Wire w0 = new Wire();
    Wire w1 = new Wire();
    Wire w2 = new Wire();
    
    Source ina = new Source(getScanner(argv[0]), sim);
    Source inb = new Source(getScanner(argv[1]), sim);
    Meter meter = new Meter(getPrintStream(argv[2]));

    ina.connectOutput(w0);
    inb.connectOutput(w2);	    
    
    and0.connectInputA(w0);
    and0.connectOutput(w1);
    and0.connectInputB(w2);
    
    meter.addTestPoint(w0);
    meter.addTestPoint(w2);
    meter.addTestPoint(w1);
    
    /* Here we check that each gate
       output agrees the gate logic. */
    and0.inputChanged(); 
    
    sim.simulate(meter);
  }
  private static Scanner getScanner(String filename){
    Scanner s=null;
    try {
       s=new Scanner(new File(filename));
    } catch(FileNotFoundException e) {
      System.out.println("Error with file "+filename+":"+e.getMessage());
      System.exit(-1);
    } 
    return s;
  }
  private static PrintStream getPrintStream(String filename) {
    PrintStream out=null;
    try {
      out = new PrintStream( new File(filename));
    } catch(FileNotFoundException e) {
      System.out.println("Error with file "+filename+":"+e.getMessage());
      System.exit(-1);
    } 
    return out;
  }
} 
