import java.util.Scanner;
import java.util.*;

public class Source implements OutSignal, UpdateListener {
  private boolean output;
  private Simulator sim;
  private Scanner data;
  private ArrayList<InSignal> drains;
  private static int nextId=0;
  private final int id;
  private StringBuffer buff;
  
  {  id = nextId++;
  }
  public Source(Scanner in, Simulator s) {
	
    buff = new StringBuffer();
	sim = s;
    data = in;
	data.useLocale(Locale.US);
    float t = data.nextFloat();
	int vali = data.nextInt();
    boolean val= vali==1;
	buff.append(t);
	buff.append('\t');
	buff.append(vali);
	buff.append('\n');
    sim.add(new ChangeEvent(this, val, t)); 
    drains = new ArrayList<InSignal>();
  }
  
  public void updateOutputValue(boolean val) {
    if(val != output) 
        output = val;
    if (data.hasNextFloat()) {
       float time = data.nextFloat();
	   int nextVali = data.nextInt();
       boolean nextValue = nextVali==1;
	   	buff.append(time);
		buff.append('\t');
		buff.append(nextVali);
		buff.append('\n');
       sim.add(new ChangeEvent(this, nextValue, time));
    }
  }
  public void propagateOutputValue() {
    for (InSignal drain: drains) 
      drain.inputValueChanged();
  }
  
  public boolean getValue() {
    return output;
  }
  public void connectOutput(InSignal drain) {
    if(drain!=null) {
      drains.add(drain);
      drain.addSource(this);
    }
  }
  public void connectDrain(InSignal drain) {
    if(drain!=null) drains.add(drain);
  }
  public void removeFromDrains(InSignal drain) {
    if(drain!=null) drains.remove(drain);
  }
  public void disconnectOutput(InSignal drain) {
    if(drain!=null){
      drains.remove(drain);
      drain.removeFromSource(this);
    }
  }
  public void disconnectAllOutput() {
    while (drains.size()!=0) {
       drains.get(0).removeFromSource(this);
       drains.remove(0);
    }
  }
  public String getDescription() {
    return getClass().getName()+"_"+id;
  }
  public void reset(){
		// Re
		output = true;
		data = new Scanner(buff.toString());
		buff = new StringBuffer();
		data.useLocale(Locale.US);
		// Set
		float t = data.nextFloat();
		int vali = data.nextInt();
		boolean val= vali==1;
		buff.append(t);
		buff.append('\t');
		buff.append(vali);
		buff.append('\n');
		sim.add(new ChangeEvent(this, val, t));
  }
}