public class Inverter extends Gate {
  public Inverter(float delay, Simulator s) {
    super(delay,nextId++, s);
  }
  public Inverter(Simulator s) {
    this(Inverter.delay, s);
  }
  public void connectInput(OutSignal output){
    source = output;
    output.connectDrain(this);
  }
  public void disconnectInput(){
    if (source != null) {
      source.removeFromDrains(this);
      source = null;
     }
  }
  public void addSource(OutSignal output){
    source = output;
  }
  public void removeFromSource(OutSignal output){
    if (source == output)  source = null;
  }
  public boolean computeOutput(){
    if (source==null) return false; // open input corresponds to high 
    boolean in = source.getValue();
    return(!in);
  } 
  public boolean hasConnectedSource() {
    return source != null;
  } 
  private OutSignal source=null;
  private static int nextId = 0;
  private static int delay = 1;
}