///////    NOr.java    ///////

/**
* Compuerta NOr
* @author Felipe Acevedo - Cristobal Barrientos - Thomas Dixon
*/ 

import java.util.*;

public class NOrGate extends Gate {
/**
*Constructor  NOrGate. Extiende de Gate
* @param delay	Delay de la Compuerta
* @param s		Instancia del Simulador 
* @param sources Arreglo de la Salida		
*/
  public NOrGate (float delay, Simulator s) {
    super(delay, nextId++, s);
    sources= new ArrayList<OutSignal>();
  }
  public NOrGate (Simulator s) {
     this(NOrGate.delay, s);
  }
  /**
  * Conecta una entrada
  *@param output Salida de una compuerta
  */
  public void connectInput(OutSignal output){
    sources.add(output);
    output.connectDrain(this);
  }
  
  /**
  *Desconecta una entrada
  */
  
  public void disconnectInput(){
    while(sources.size() != 0) {
      sources.get(0).removeFromDrains(this);
      sources.remove(0);
    }
  }
  
  /**
  * Agrega una entrada tipo Source
  * @param output  Salida de una compuerta
  */
  public void addSource(OutSignal output) {
    sources.add(output);
  }
  
  /**
  *Remueve una seal de entrada
  */
  public void removeFromSource(OutSignal output){
    sources.remove(output);
  }
  /**
  *Entrega el resultado de la compuerta
  *@return <tt>Salida de la compuerta</tt> 
  */
  public boolean computeOutput(){
    boolean result=false;
    for ( OutSignal in: sources)
       result = !(result || in.getValue()); 
    return result;
  }
  
  /**
  *Devuelve si tiene conectada las entradas
  *@return <tt> Retorno si tiene conectedas las entradas</tt>
  */
  
  public boolean hasConnectedSource() {
    return sources.size()>0;
  }
  
  /**
  *Arreglo para la salida
  */
  
  private ArrayList<OutSignal> sources; //arreglo de salida
  
  /**
  * Numero Id de la compuerta
  */
  
  private static int nextId = 0;
  /**
  *Delay de la compuerta
  */
  
  private static int delay = 2;
 
}